﻿<?
error_reporting(E_ALL ^ E_NOTICE ^ E_DEPRECATED);

require("comun/class_abm.php");
require("comun/class_db.php");
require("comun/class_paginado.php");
require("comun/class_orderby.php");

//conexión a la bd
$db = new class_db("localhost", "root", "", "demoabm", "utf8");
$db->mostrarErrores = true;
$db->connect();

$abm = new class_abm();
$abm->tabla = "usuarios";
$abm->charset = "utf-8";
$abm->registros_por_pagina = 5;
$abm->textoTituloFormularioAgregar = "Agregar usuario";
$abm->textoTituloFormularioEdicion = "Editar usuario";
$abm->adicionalesInsert = ", fechaAlta=NOW()";
$abm->columnasFormBuscar = 3;

function subirFoto($id, $tabla){
	//solo a modo de ejemplo. Retorna true si es una imagen válida o si no se envia archivo
	
	if (is_uploaded_file($_FILES['archivo']['tmp_name'])) {
		if( is_array(@getimagesize($_FILES['archivo']['tmp_name']))){
			//es una imagen válida
			return true;
		}else{
			//no pudo obtener las dimensiones, asumo que no es valida
			return false;
		}
	}else{
		//retorna true porque no es obligatorio subir una imagen
		return true;
	}
}

$abm->campos = array(
		array("campo" => "usuario", 
					"tipo" => "texto", 
					"titulo" => "Usuario", 
					"maxLen" => 30,
					"customPrintListado" => "<a href='javascript:alert(\"Ejemplo customPrintListado. id={id}\")' title='Ver usuario'>%s</a>",
					"requerido" => true,
					"hint" => "El usuario no debe existir",
					"exportar" => true,
					"buscar" => true,
					"buscarOperador" => "="
					), 
		array("campo" => "pass", 
					"tipo" => "password", 
					"titulo" => "Contraseña", 
					"maxLen" => 30,
					"noListar" => true,
					"requerido" => true,
					"hint" => "Elija una contraseña segura",
					"exportar" => true
					),
		array("campo" => "activo", 
					"tipo" => "bit", 
					"titulo" => "Activo", 
					"valorPredefinido" => "1",
					"centrarColumna" => true,
					"hint" => "Indica si el usuario estará activo",
					"exportar" => true
					),
		array("campo" => "nivel", 
					"tipo" => "combo", 
					"titulo" => "Nivel", 
					"datos" => array("ADMIN"=>"Administrador", "USUARIO"=>"Usuario"),
					"valorPredefinido" => "USUARIO",
					"exportar" => true,
					"buscar" => true
					),
		array("campo" => "fechaAlta", 
					"tipo" => "fecha", 
					"titulo" => "Fecha alta", 
					"tituloBuscar" => "Fecha alta >=", 
					"noNuevo" => true,
					"requerido" => true,
					"exportar" => true,
					"buscar" => true,
					"buscarOperador" => ">="
					),
		array("campo" => "email", 
					"tipo" => "texto", 
					"titulo" => "Email", 
					"maxLen" => 70,
					"requerido" => true,
					"exportar" => true,
					"buscar" => true
					),
		array("separador" => "Datos personales"
					),
		array("campo" => "nombre", 
					"tipo" => "texto", 
					"titulo" => "Nombre", 
					"maxLen" => 50,
					"exportar" => true,
					"buscar" => true
					),
		array("campo" => "apellido", 
					"tipo" => "texto", 
					"titulo" => "Apellido", 
					"maxLen" => 50,
					"exportar" => true,
					"buscar" => true
					),
		array("campo" => "comentarios", 
					"tipo" => "textarea", 
					"titulo" => "Comentarios", 
					"noListar" => true,
					"hint" => "Ingrese cualquier comentario que desee pero no se abuse porque este es un ejemplo de hint largo."
					),
		array("campo" => "paisId", 
					"tipo" => "dbCombo", 
					"sqlQuery" => "SELECT * FROM paises ORDER BY pais", 
					"campoValor" => "id", 
					"campoTexto" => "pais",
					"joinTable" => "paises", 
					"joinCondition" => "LEFT", 
					"titulo" => "País",
					"incluirOpcionVacia" => true,
					"requerido" => true,
					"buscar" => true
					),
		array("campo" => "ultimoLogin", 
					"tipo" => "fecha", 
					"titulo" => "Ultimo login",
					"noEditar" => true, 
					"noListar" => true,
					"noNuevo" => true
					),
		array("campo" => "archivo", 
					"tipo" => "upload", 
					"titulo" => "Foto", 
					"uploadFunction" => "subirFoto",
					"borrarSiUploadFalla" => true
					)
		);

$abm->exportar_verificar();

header("Content-Type: text/html; charset=UTF-8");
?>
<html>
<head>
	<meta http-equiv="content-type" content="text/html; charset=UTF-8">
	<title>Demo abm</title>

	<!-- Estilos del ABM -->
	<link href="css/abm.css" rel="stylesheet" type="text/css">
	
	<!-- Estilos del ejemplo -->
	<link href="css/sitio.css" rel="stylesheet" type="text/css">

	<!-- JQuery, JQuery-Ui -->
	<script type="text/javascript" src="js/jquery.js"></script>
	<script type="text/javascript" src="js/jquery-ui/jquery-ui.js"></script>
	<script type="text/javascript" src="js/jquery-ui/lang-datepicker-es.js"></script>
	<link href="js/jquery-ui/jquery-ui.css" rel="stylesheet" type="text/css">
	
	<!-- JQuery validationEngine -->
	<link href="js/validationEngine/validationEngine.jquery.css" rel="stylesheet" type="text/css"/>
	<script src="js/validationEngine/languages/jquery.validationEngine-es.js" type="text/javascript" charset="utf-8"></script>
	<script src="js/validationEngine/jquery.validationEngine.js" type="text/javascript" charset="utf-8"></script>

    <!-- limitador de texto para textarea -->
	<script type="text/javascript" src="js/jquery.inputlimiter.js"></script>
	
</head>
<body>

<?
$abm->generarAbm("", "Administrar usuarios");

echo "<br/><br/>";

if ( $_GET['vercodigo'] ){
	highlight_file(__FILE__);
}else{
	echo "<a href='?vercodigo=1'>Ver código fuente</a>";
}
?>

</body>
</html>